Type _GameObject

	Global List:TList = New TList
	Global id:Int = 0
	
	Field name:String
	
	Method CreateNew:_GameObject( name:String = Null , add:Int = True )
		
		If( Not name )
			get_def_name()
		Else
			Self.name = name	
		End If
			
		If( add ) Then add_to_list()
		
		Return Self
	
	End Method
	
	Method get_def_name()
		name = "def_name_" + id
		id :+ 1
	End Method
	
	Method add_to_list()
		List.addlast(Self)
	End Method
	
	Method rem_from_list()
		List.remove(Self)
	End Method
	
	Method update()
	End Method
	
	Method draw()
	End Method
	
	Function get:_GameObject(  obj_name:String )
		For Local obj:_GameObject = EachIn _GameObject.List
			If ( obj.name = obj_name ) Then Return obj
		Next		
	End Function

	Function Update_All() 
		For Local o:_GameObject = EachIn List
			o.Update()
		Next	
	End Function
	
	Function Draw_All() 
		For Local o:_GameObject = EachIn List
			o.Draw()
		Next			
	End Function	
	
End Type	
